diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/AUTHORS ns-3.34/AUTHORS
--- ns-3.33/AUTHORS	2021-01-09 10:19:21.000000000 -0800
+++ ns-3.34/AUTHORS	2021-07-14 10:31:06.000000000 -0700
@@ -3,14 +3,17 @@
 Danilo Abrignani (dabrignani@gmail.com)
 Michele Abruzzese (oniricha04@gmail.com)
 Alexander Afanasyev (alexander.afanasyev@ucla.edu)
+Chetan Agrawal (chetanag35@gmail.com)
 Rohit Agarwal (mindprince@gmail.com)
 Piyush Aggarwal (piyush8311@gmail.com)
+Alessandro Aimi (alleaimi95@gmail.com)
 Zoraze Ali (zoraze.ali@cttc.es)
 Eduardo Almeida (enmsa@outlook.pt)
 Robert Ammon (ammo6818@vandals.uidaho.edu)
 Kirill Andreev (andreev@iitp.ru)
 Dean Armstrong (deanarm@gmail.com)
 Gabriel Arrobo (gab.arrobo@gmail.com)
+Zakaria Helal Arzoo (arzoozakaria@gmail.com)
 Stefano Avallone (stefano.avallone@unina.it)
 Vignesh Babu (ns3-dev@esk.fraunhofer.de)
 Ghada Badawy (gbadawy@gmail.com)
@@ -41,11 +44,14 @@
 Scott Carpenter (scarpen@ncsu.edu)
 Tiago Cerqueira (tiago.miguel43@gmail.com)
 Egemen K. Cetinkaya (ekc@iitc.ku.edu)
+Nitya Chandra (nityachandra6@gmail.com)
 Angelos Chatzipapas (chatzipa@ceid.upatras.gr)
 Aditya Chaudhary (adityach2002@gmail.com)
+Shobhit Chaurasia (000shobhitchaurasia@gmail.com)
 Luciano Jerez Chaves (ljerezchaves@gmail.com)
 Eugene Chemeritskiy (echemeritskiy@arccn.ru)
 Yufei Cheng (yfcheng@ittc.ku.edu)
+Aditya Chirania (adityachirania97@gmail.com)
 Zhao Wen Chow (shu@mos.ics.keio.ac.jp)
 Andrey Churin (aachurin@gmail.com)
 Micolaj Chwalisz (chwalisz@tkn.tu-berlin.de)
@@ -59,6 +65,7 @@
 Ankit Deepak (adadeepak8@gmail.com)
 Christophe Delahaye (christophe.delahaye@orange.com)
 Sébastien Deronne (sebastien.deronne@gmail.com)
+Ameya Deshpande (ameyanrd@outlook.com)
 Christoph Döpmann (doepmanc@informatik.hu-berlin.de)
 Jordan Dorham (dorham1@llnl.gov)
 Craig Dowell (craigdo@ee.washington.edu)
@@ -75,6 +82,7 @@
 Juliana Freitag Borin (juliana.freitag@gmail.com)
 Piotr Gawlowicz (gawlowicz.p@gmail.com)
 Eric Gamess (egamess@gmail.com)
+Shiva Gantha (ganthashiva@gmail.com)
 Yida Gao (yidapb@gmail.com)
 Thomas Geithner (thomas.geithner@dai-labor.de)
 Ashim Ghosh (ashim.atiit@gmail.com)
@@ -140,6 +148,7 @@
 Mathieu Lacage (mathieu.lacage@inria.fr)
 Emmanuelle Laprise (emmmanuelle.laprise@bluekazoo.ca)
 Harsh Lara (harshapplefan@gmail.com)
+Mattia Lecci (mattia.lecci@gmail.com)
 Kristijan Lenković (k.lenkovic@me.com)
 Daniel Lertpratchya (nikkipui@gmail.com)
 Brett Levasseur (brettl20@gmail.com)
@@ -156,6 +165,7 @@
 Rubén Martínez (rmartinez@deic.uab.cat)
 Ryan Mast (mast9@llnl.gov)
 Fabian Mauchle (f1mauchl@hsr.ch)
+Mauriyin (haoyin@uw.edu)
 Andrey Mazo (mazo@iitp.ru)
 Jonathan McCrohan (jmccroha@tcd.ie)
 Andrew McGregor (andrewmcgr@gmail.com)
@@ -172,12 +182,16 @@
 Michele Muccio (michelemuccio@virgilio.it)
 Esteban Municio (esteban.municio@urjc.es)
 Sidharth Nabar (snabar@uw.edu)
+Sharan Naribole (sharan.naribole@gmail.com)
 Hemanth Narra (hemanth@ittc.ku.edu)
 Roman Naumann (naumann@informatik.hu-berlin.de)
+Mohtashim Nawaz (nawazmohtashim@gmail.com)
+Sachin Nayak (sachinn@uw.edu)
 Ben Newton (bn@cs.unc.edu)
 Cecchi Niccolò (insa@igeek.it)
 Andreas Nilsson (andrnils@gmail.com)
 Jaume Nin (jnin@cttc.es)
+Niwedita (niwedita.dakshana2017@gmail.com)
 Michael Nowatkowski (nowatkom@gmail.com)
 Anh Nguyen (annguyen@ittc.ku.edu)
 Duy Nguyen (duy@soe.ucsc.edu)
@@ -232,6 +246,7 @@
 Charitha Sangaraju (charitha29193@gmail.com)
 Siddharth Santurkar (siddharth.santurkar@ieee.org)
 Gaurav Sathe (gaurav.sathe@tcs.com)
+Chappidi Yoga Satwik (satwik.chappidi@iitkgp.ac.in)
 Robert R. Schmidt (rschmi@gmx.net)
 Florian Schmidt (Florian.Schmidt@cs.rwth-aachen.de)
 Surya Seetharaman (suryaseetharaman.9@gmail.com)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/bindings/python/ns3modulescan-modular.py ns-3.34/bindings/python/ns3modulescan-modular.py
--- ns-3.33/bindings/python/ns3modulescan-modular.py	2021-01-09 10:19:21.000000000 -0800
+++ ns-3.34/bindings/python/ns3modulescan-modular.py	2021-07-14 10:31:06.000000000 -0700
@@ -251,7 +251,7 @@
     output_file = open(output_file_name, "wt")
     output_sink = FileCodeSink(output_file)
 
-    # if there exists a scan-header.h file in src/<module>/bindings,
+    # if there exists a scan-header.h file in src/<module>/bindings or contrib/<module>/bindings,
     # scan it, otherwise scan ns3/xxxx-module.h.
     scan_header = os.path.join(os.path.dirname(output_file_name), "scan-header.h")
     if not os.path.exists(scan_header):
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/bindings/python/ns3modulescan.py ns-3.34/bindings/python/ns3modulescan.py
--- ns-3.33/bindings/python/ns3modulescan.py	2021-01-09 10:19:21.000000000 -0800
+++ ns-3.34/bindings/python/ns3modulescan.py	2021-07-14 10:31:06.000000000 -0700
@@ -4,7 +4,7 @@
 import os.path
 
 import pybindgen.settings
-from pybindgen.gccxmlparser import ModuleParser, PygenClassifier, PygenSection, WrapperWarning
+from pybindgen.castxmlparser import ModuleParser, PygenClassifier, PygenSection, WrapperWarning
 from pybindgen.typehandlers.codesink import FileCodeSink
 from pygccxml.declarations import templates
 from pygccxml.declarations.class_declaration import class_t
@@ -18,7 +18,7 @@
 import ns3modulegen_core_customizations
 
 
-## silence gccxmlparser errors; we only want error handling in the
+## silence castxmlparser errors; we only want error handling in the
 ## generated python script, not while scanning.
 class ErrorHandler(pybindgen.settings.ErrorHandler):
     def handle_error(self, dummy_wrapper, dummy_exception, dummy_traceback_):
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/bindings/python/wscript ns-3.34/bindings/python/wscript
--- ns-3.33/bindings/python/wscript	2021-01-09 10:19:21.000000000 -0800
+++ ns-3.34/bindings/python/wscript	2021-07-14 10:31:06.000000000 -0700
@@ -18,9 +18,9 @@
 # version as, e.g. '0.21.0'
 # If specifying a commit on the development tree, specify it like this based
 # on 'git describe --tags' command.  Example, if the latest release was 0.21.0,
-# and 'git decribe --tags' reports "0.21.0-6-g8e7c0a9", then write the
+# and 'git describe --tags' reports "0.21.0-6-g8e7c0a9", then write the
 # PYBINDGEN version string below as '0.21.0.post6+ng8e7c0a9'
-REQUIRED_PYBINDGEN_VERSION = '0.21.0.post15+nga587377'
+REQUIRED_PYBINDGEN_VERSION = '0.22.0'
 REQUIRED_PYGCCXML_VERSION = (2, 0, 1)
 REQUIRED_CASTXML_VERSION = '0.2'
 
@@ -390,6 +390,8 @@
     def run(self):
         self.inputs = [self.bld.bldnode.find_resource("ns3/{0}-module.h".format(self.module))]
         self.outputs = [self.bld.srcnode.find_resource("src/{}/bindings/modulegen__{}.py".format(self.module, self.target))]
+        if self.outputs[0] is None:
+            self.outputs = [self.bld.srcnode.find_resource("contrib/{}/bindings/modulegen__{}.py".format(self.module, self.target))]
         top_builddir = self.bld.bldnode.abspath()
         module_path = get_module_path(self.bld, self.module)
         headers_map = get_headers_map(self.bld)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/contrib/wscript ns-3.34/contrib/wscript
--- ns-3.33/contrib/wscript	2021-01-09 10:19:21.000000000 -0800
+++ ns-3.34/contrib/wscript	2021-07-14 10:31:06.000000000 -0700
@@ -197,7 +197,7 @@
                       Warning, stacklevel=2)
         return
 
-    if ("ns3-%s" % (module,)) not in env.NS3_ENABLED_MODULES:
+    if ("ns3-%s" % (module,)) not in env.NS3_ENABLED_CONTRIBUTED_MODULES:
         #print "bindings for module %s which is not enabled, skip" % module)
         return
 
@@ -260,6 +260,7 @@
     bindgen.before = ['cxxprogram', 'cxxshlib', 'cxxstlib']
     bindgen.after = 'gen_ns3_module_header'
     bindgen.name = "pybindgen(ns3 module %s)" % module
+    bindgen.module = module
     bindgen.install_path = None
 
     # generate the extension module
@@ -267,7 +268,8 @@
     pymod.source = ['bindings/ns3module.cc']
     pymod.target = '%s/%s' % (module_target_dir, extension_name)
     pymod.name = 'ns3module_%s' % module
-    pymod.use = ["%s" % mod for mod in pymod.env['NS3_ENABLED_MODULES']] #  Should be '"ns3-"+module', but see bug 1117
+    pymod.module = module
+    pymod.use = ["%s" % mod for mod in pymod.env['NS3_ENABLED_CONTRIBUTED_MODULES']]
     if pymod.env['ENABLE_STATIC_NS3']:
         if sys.platform == 'darwin':
             pymod.env.append_value('LINKFLAGS', '-Wl,-all_load')
@@ -282,6 +284,10 @@
             pymod.env.append_value('LINKFLAGS', '-Wl,-Bdynamic,--no-whole-archive')
     defines = list(pymod.env['DEFINES'])
     defines.extend(['NS_DEPRECATED=', 'NS3_DEPRECATED_H'])
+    defines.extend(['NS_DEPRECATED_3_34=', 'NS3_DEPRECATED_H'])
+    defines.extend(['NS_DEPRECATED_3_32=', 'NS3_DEPRECATED_H'])
+    defines.extend(['NS_DEPRECATED_3_31=', 'NS3_DEPRECATED_H'])
+    defines.extend(['NS_DEPRECATED_3_30=', 'NS3_DEPRECATED_H'])
     if Utils.unversioned_sys_platform() == 'win32':
         try:
             defines.remove('_DEBUG') # causes undefined symbols on win32
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/doc/doxygen.conf ns-3.34/doc/doxygen.conf
--- ns-3.33/doc/doxygen.conf	2021-01-09 10:19:21.000000000 -0800
+++ ns-3.34/doc/doxygen.conf	2021-07-14 10:31:06.000000000 -0700
@@ -275,6 +275,7 @@
 ##     Func<MyClass> ();
 
 ALIASES                = "bugid{1}=<a href=\"http://www.nsnam.org/bugzilla/show_bug.cgi?id=\1\">Bug \1</a>" \
+                         "issueid{1}=<a href=\"https://gitlab.com/nsnam/ns-3-dev/-/issues/\1\">Issue \1</a>" \
                          "internal=\par \b Internal:" \
                          "pname{1}=<span class=\"params\"><span class=\"paramname\">\1</span></span>" \
                          "RFC{1}=<a href=\"http://datatracker.ietf.org/doc/rfc\1/\">RFC \1</a>" \
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/doc/doxygen.warnings.report.sh ns-3.34/doc/doxygen.warnings.report.sh
--- ns-3.33/doc/doxygen.warnings.report.sh	2021-01-09 10:19:21.000000000 -0800
+++ ns-3.34/doc/doxygen.warnings.report.sh	2021-07-14 10:31:06.000000000 -0700
@@ -1,5 +1,5 @@
 #!/bin/bash
-# -*- indent-tabs-mode:nil; -*- 
+# -*- indent-tabs-mode:nil; -*-
 
 
 # Process doxygen log to generate sorted list of top offenders.
@@ -42,12 +42,12 @@
 {
     synopsis_short
     cat <<-EOF
-    
+
     Run doxygen to generate all errors; report error counts
     by module and file.
-    
+
     -i  Skip the build, try print-introspected-doxygen anyway.
-    
+
     -s  Skip doxygen run; use existing <log-file>.
     -w  Skip doxygen run; use existing warnings log doc/$WARNINGSLOGFILE
     -l  Skip doxygen run; use the normal doxygen log doc/$STANDARDLOGFILE
@@ -61,7 +61,7 @@
 
     -v  Show detailed output from each step.
     -h  Print this usage message
-        
+
     The default behavior is to modify doxygen.conf temporarily to
     report all undocumented elements, and to reduce the run time.
     The output of this special run is kept in doc/$WARNINGSLOGFILE.
@@ -73,13 +73,13 @@
     The first two use a specified or the standard log file;
     the -s option uses the warnings log from a prior run.
     Only the first of -f <log-file>, -s, or -l will have effect.
-            
+
     The -e and -t options exclude examples and test directories
     from the counts.  The -m option only includes a specific module.
     The -F option only includes files (or warnings) matching the <regex>.
     The -m and -F options append the relevant warnings after the
     numerical report.  These can be used in any combination.
-    
+
 EOF
     exit 0
 }
@@ -129,7 +129,7 @@
         fi
     fi
 }
-   
+
 
 # Argument processing ------------------
 #
@@ -140,15 +140,17 @@
 # -l
 use_standard=0
 # skip doxygen run; using existing log file
-skip_doxy=0 
-# skip print-introspected-doxygen, avoiding a build 
-skip_intro=0 
+skip_doxy=0
+# skip print-introspected-doxygen, avoiding a build
+skip_intro=0
 
 # Filtering flags
 filter_blacklist=1
 filter_examples=0
 filter_test=0
+explicit_m_option=0
 filter_module=""
+explicit_f_option=0
 filter_in=""
 filter_out=""
 
@@ -156,20 +158,24 @@
 
     case $option in
     (b)  filter_blacklist=0       ;;
-    
+
     (e)  filter_examples=1        ;;
 
-    (f)  filter_in="$OPTARG"      ;;
+    (f)  filter_in="$OPTARG"
+         explicit_f_option=1
+         ;;
 
     (F)  filter_out="$OPTARG"     ;;
 
     (h)  usage                    ;;
-    
+
     (i)  skip_intro=1             ;;
-    
+
     (l)  use_standard=1           ;;
 
-    (m)  filter_module="$OPTARG"  ;;
+    (m)  filter_module="$OPTARG"
+         explicit_m_option=1
+         ;;
 
     (s)  use_filearg=1
          logfile_arg="$OPTARG"
@@ -184,11 +190,11 @@
     (w)  use_filearg=1
          logfile_arg="$DIR/$WARNINGSLOGFILE"
          ;;
-         
+
     (:)  echo "$me: Missing argument to -$OPTARG" ; synopsis ;;
-    
+
     (\?) echo "$me: Invalid option: -$OPTARG"     ; synopsis ;;
-        
+
     esac
 done
 
@@ -202,7 +208,7 @@
         synopsis
     fi
 }
-    
+
 # Log file -----------------------------
 #
 
@@ -225,6 +231,10 @@
     eval "${param}=\"${!param:-}${!param:+\\|}$token\""
 }
 
+# Explicit -f or -m with empty args should filter out all, not pass all
+[[ $explicit_f_option -eq 1 && "${filter_in:-}" == "" ]] && filter_out=".*"
+[[ $explicit_m_option -eq 1 && "${filter_module:-}" == "" ]] && filter_out=".*"
+
 # Filter in regular expression for -m and -f
 filter_inRE=""
 [[ "$filter_module" != "" ]] && REappend filter_inRE src/$filter_module
@@ -244,7 +254,7 @@
 REappend filter_blacklistRE "Schedule\\(Now\\|Destroy\\)(\\(MEM\\|void\\)"
 
 #   ATTRIBUTE_HELPER_CPP( and _HEADER(
-REappend filter_blacklistRE "ATTRIBUTE_HELPER_\\(CPP\\|HEADER\\)("
+REappend filter_blacklistRE "ATTRIBUTE_HELPER_\\(CPP\\|HEADER\\)"
 
 # Filter out regular expression for black list, -e, -t and -F
 filter_outRE=""
@@ -304,7 +314,7 @@
     conf=doc/doxygen.conf
     cp $conf ${conf}.bak
     cat <<-EOF >> $conf
-    
+
     # doxygen.warnings.report.sh:
     EXTRACT_ALL = no
     HAVE_DOT = no
@@ -333,12 +343,13 @@
     fi
 
     # Waf insists on writing cruft to stdout
-    sed -i -E '/^Waf:/d' doc/$intro_h
+    sed -i.bak -E '/^Waf:/d' doc/$intro_h
+    rm doc/$intro_h.bak
 
     verbose -n "Rebuilding doxygen docs with full errors"
     (cd "$ROOT" && ./waf --doxygen-no-build >&6 2>&6 )
     status_report $? "./waf --doxygen-no-build"
-    
+
     # Swap back to original config
     rm -f $conf
     mv -f $conf.bak $conf
@@ -394,7 +405,7 @@
 # Doxygen prints the additional parameters on separate lines,
 # so they don't show up in the totals above.
 # Rather than work too hard to get the exact number for each file,
-# we just list the total here. 
+# we just list the total here.
 addlparam=$(                                  \
     grep "^  parameter '" "$LOG"            | \
     wc -l                                   | \
@@ -464,7 +475,7 @@
 echo
 echo "Warnings by file (alphabetical)"
 echo
-echo "Count File" 
+echo "Count File"
 echo "----- ----------------------------------"
 echo "$undocfiles"
 echo "----------------------------------------"
@@ -473,7 +484,7 @@
 echo
 echo "Warnings by file (numerical)"
 echo
-echo "Count File" 
+echo "Count File"
 echo "----- ----------------------------------"
 echo "$undocsort"
 echo "----------------------------------------"
@@ -486,12 +497,33 @@
 printf "%6d files\n" $filecount
 printf "%6d warnings\n" $warncount
 
+# Return status based on warnings
+exit_status=$((warncount > 0))
+
+# if [ "${filter_inRE:-}" != "" ] ; then
+#     if [ "$filterin" != "" ] ; then
+#         echo
+#         echo
+#         echo "Filtered Warnings"
+#         echo "========================================"
+#         echo "$filterin"
+#         exit_status=1
+#     else
+#         exit_status=0
+#     fi
+# fi
+
 if [ "$filterin" != "" ] ; then
     echo
     echo
     echo "Filtered Warnings"
     echo "========================================"
     echo "$filterin"
+    exit_status=1
+else
+    exit_status=0
 fi
 
 status_report 0 $me
+
+exit $exit_status
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/doc/models/Makefile ns-3.34/doc/models/Makefile
--- ns-3.33/doc/models/Makefile	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/doc/models/Makefile	2021-07-14 10:31:06.000000000 -0700
@@ -90,7 +90,9 @@
 	$(SRC)/traffic-control/doc/codel.rst \
 	$(SRC)/traffic-control/doc/cobalt.rst \
 	$(SRC)/traffic-control/doc/fq-codel.rst \
+	$(SRC)/traffic-control/doc/fq-cobalt.rst \
 	$(SRC)/traffic-control/doc/pie.rst \
+	$(SRC)/traffic-control/doc/fq-pie.rst \
 	$(SRC)/traffic-control/doc/mq.rst \
 	$(SRC)/spectrum/doc/spectrum.rst \
 	$(SRC)/netanim/doc/animation.rst \
@@ -134,8 +136,20 @@
 	$(SRC)/internet/doc/figures/dce-linux-reno-vs-ns3-linux-reno.png \
 	$(SRC)/internet/doc/figures/dce-linux-reno-vs-ns3-new-reno.png \
 	$(SRC)/internet/doc/figures/ns3-new-reno-vs-ns3-linux-reno.png \
+	$(SRC)/internet/doc/figures/ns3-bbr-vs-linux-bbr.png \
 	$(SRC)/wifi/doc/source/figures/WifiArchitecture.dia \
+	$(SRC)/wifi/doc/source/figures/PhyEntityHierarchy.dia \
+	$(SRC)/wifi/doc/source/figures/WifiPpduHierarchy.dia \
+	$(SRC)/wifi/doc/source/figures/FemHierarchy.dia \
 	$(SRC)/wifi/doc/source/figures/snir.dia \
+	$(SRC)/wifi/doc/source/figures/ack-su-format.pdf \
+	$(SRC)/wifi/doc/source/figures/ack-su-format.png \
+	$(SRC)/wifi/doc/source/figures/mu-bar.pdf \
+	$(SRC)/wifi/doc/source/figures/mu-bar.png \
+	$(SRC)/wifi/doc/source/figures/aggr-mu-bar.pdf \
+	$(SRC)/wifi/doc/source/figures/aggr-mu-bar.png \
+	$(SRC)/wifi/doc/source/figures/ul-ofdma.pdf \
+	$(SRC)/wifi/doc/source/figures/ul-ofdma.png \
 	$(SRC)/wifi/doc/source/figures/clear-channel.eps \
 	$(SRC)/wifi/doc/source/figures/nist-frame-success-rate.eps \
 	$(SRC)/wifi/doc/source/figures/nist-frame-success-rate-n.eps \
@@ -352,6 +366,9 @@
 	$(FIGURES)/routing.eps \
 	$(FIGURES)/routing-specialization.eps \
 	$(FIGURES)/WifiArchitecture.eps \
+	$(FIGURES)/PhyEntityHierarchy.eps \
+	$(FIGURES)/WifiPpduHierarchy.eps \
+	$(FIGURES)/FemHierarchy.eps \
 	$(FIGURES)/snir.eps \
 	$(FIGURES)/WimaxArchitecture.eps \
 	$(FIGURES)/epc-ctrl-arch.eps \
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/doc/ns3_html_theme/static/ns3_links.js ns-3.34/doc/ns3_html_theme/static/ns3_links.js
--- ns-3.33/doc/ns3_html_theme/static/ns3_links.js	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/doc/ns3_html_theme/static/ns3_links.js	2021-07-14 10:31:06.000000000 -0700
@@ -1,8 +1,8 @@
 // nsnam.org links, independent of version
-var ns3_site = "http://www.nsnam.org/";
+var ns3_site = "https://www.nsnam.org/";
 var ns3_home = ns3_site + "";
 var ns3_wiki = ns3_site + "wiki";
-var ns3_bugs = ns3_site + "bugzilla";
+var ns3_bugs = "https://gitlab.com/nsnam/ns-3-dev/-/issues";
 
 // Links that depend on version:
 // Defined in ns3_version.js:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/examples/channel-models/three-gpp-v2v-channel-example.cc ns-3.34/examples/channel-models/three-gpp-v2v-channel-example.cc
--- ns-3.33/examples/channel-models/three-gpp-v2v-channel-example.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/examples/channel-models/three-gpp-v2v-channel-example.cc	2021-07-14 10:31:06.000000000 -0700
@@ -41,7 +41,7 @@
 #include "ns3/core-module.h"
 #include "ns3/network-module.h"
 #include <fstream>
-#include "ns3/three-gpp-antenna-array-model.h"
+#include "ns3/uniform-planar-array.h"
 #include "ns3/three-gpp-spectrum-propagation-loss-model.h"
 #include "ns3/three-gpp-v2v-propagation-loss-model.h"
 #include "ns3/three-gpp-channel-model.h"
@@ -61,9 +61,9 @@
  * \param otherDevice the device towards which point the beam
  */
 static void
-DoBeamforming (Ptr<NetDevice> thisDevice, Ptr<ThreeGppAntennaArrayModel> thisAntenna, Ptr<NetDevice> otherDevice)
+DoBeamforming (Ptr<NetDevice> thisDevice, Ptr<PhasedArrayModel> thisAntenna, Ptr<NetDevice> otherDevice)
 {
-  ThreeGppAntennaArrayModel::ComplexVector antennaWeights;
+  PhasedArrayModel::ComplexVector antennaWeights;
 
   // retrieve the position of the two devices
   Vector aPos = thisDevice->GetNode ()->GetObject<MobilityModel> ()->GetPosition ();
@@ -72,31 +72,8 @@
   // compute the azimuth and the elevation angles
   Angles completeAngle (bPos,aPos);
 
-  double hAngleRadian = fmod (completeAngle.phi, 2.0 * M_PI); // the azimuth angle
-  if (hAngleRadian < 0)
-    {
-      hAngleRadian += 2.0 * M_PI;
-    }
-  double vAngleRadian = completeAngle.theta; // the elevation angle
-
-  // retrieve the number of antenna elements
-  int totNoArrayElements = thisAntenna->GetNumberOfElements ();
-
-  // the total power is divided equally among the antenna elements
-  double power = 1 / sqrt (totNoArrayElements);
-
-  // compute the antenna weights
-  for (int ind = 0; ind < totNoArrayElements; ind++)
-    {
-      Vector loc = thisAntenna->GetElementLocation (ind);
-      double phase = -2 * M_PI * (sin (vAngleRadian) * cos (hAngleRadian) * loc.x
-                                  + sin (vAngleRadian) * sin (hAngleRadian) * loc.y
-                                  + cos (vAngleRadian) * loc.z);
-      antennaWeights.push_back (exp (std::complex<double> (0, phase)) * power);
-    }
-
-  // store the antenna weights
-  thisAntenna->SetBeamformingVector (antennaWeights);
+  PhasedArrayModel::ComplexVector bf = thisAntenna->GetBeamformingVector (completeAngle);
+  thisAntenna->SetBeamformingVector (bf);
 }
 
 /**
@@ -212,8 +189,8 @@
   rxDev->SetNode (nodes.Get (1));
 
   // create the antenna objects and set their dimensions
-  Ptr<ThreeGppAntennaArrayModel> txAntenna = CreateObjectWithAttributes<ThreeGppAntennaArrayModel> ("NumColumns", UintegerValue (2), "NumRows", UintegerValue (2), "BearingAngle", DoubleValue (-M_PI / 2));
-  Ptr<ThreeGppAntennaArrayModel> rxAntenna = CreateObjectWithAttributes<ThreeGppAntennaArrayModel> ("NumColumns", UintegerValue (2), "NumRows", UintegerValue (2), "BearingAngle", DoubleValue (M_PI / 2));
+  Ptr<PhasedArrayModel> txAntenna = CreateObjectWithAttributes<UniformPlanarArray> ("NumColumns", UintegerValue (2), "NumRows", UintegerValue (2), "BearingAngle", DoubleValue (-M_PI / 2));
+  Ptr<PhasedArrayModel> rxAntenna = CreateObjectWithAttributes<UniformPlanarArray> ("NumColumns", UintegerValue (2), "NumRows", UintegerValue (2), "BearingAngle", DoubleValue (M_PI / 2));
 
   Ptr<MobilityModel> txMob;
   Ptr<MobilityModel> rxMob;
